Package org.bukkit.block

# Enum Class BlockFace

java.lang.Object
java.lang.Enum<BlockFace>
org.bukkit.block.BlockFace

All Implemented Interfaces:
  `Serializable`, `Comparable<BlockFace>`, `Constable`

public enum BlockFace extends Enum<BlockFace>
Represents the face of a block

## Nested Class Summary

## Nested classes/interfaces inherited from class java.lang.Enum

`Enum.EnumDesc<E extends Enum<E>>`

## Enum Constant Summary

Enum Constants
Enum Constant
Description
`DOWN`
`EAST`
`EAST_NORTH_EAST`
`EAST_SOUTH_EAST`
`NORTH`
`NORTH_EAST`
`NORTH_NORTH_EAST`
`NORTH_NORTH_WEST`
`NORTH_WEST`
`SELF`
`SOUTH`
`SOUTH_EAST`
`SOUTH_SOUTH_EAST`
`SOUTH_SOUTH_WEST`
`SOUTH_WEST`
`UP`
`WEST`
`WEST_NORTH_WEST`
`WEST_SOUTH_WEST`

## Method Summary

Modifier and Type
Method
Description
`@NotNull Vector`
`getDirection()`
Gets the normal vector corresponding to this block face.
`int`
`getModX()`
Get the amount of X-coordinates to modify to get the represented block
`int`
`getModY()`
Get the amount of Y-coordinates to modify to get the represented block
`int`
`getModZ()`
Get the amount of Z-coordinates to modify to get the represented block
`@NotNull BlockFace`
`getOppositeFace()`
`boolean`
`isCartesian()`
Returns true if this face is aligned with one of the unit axes in 3D Cartesian space (ie NORTH, SOUTH, EAST, WEST, UP, DOWN).
`static BlockFace`
`valueOf(String name)`
Returns the enum constant of this class with the specified name.
`static BlockFace[]`
`values()`
Returns an array containing the constants of this enum class, in the order they are declared.

### Methods inherited from class java.lang.Enum

`clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

### Methods inherited from class java.lang.Object

`getClass, notify, notifyAll, wait, wait, wait`

## Enum Constant Details

### NORTH

public static final BlockFace NORTH

### EAST

public static final BlockFace EAST

### SOUTH

public static final BlockFace SOUTH

### WEST

public static final BlockFace WEST

### UP

public static final BlockFace UP

### DOWN

public static final BlockFace DOWN

### NORTH_EAST

public static final BlockFace NORTH_EAST

### NORTH_WEST

public static final BlockFace NORTH_WEST

### SOUTH_EAST

public static final BlockFace SOUTH_EAST

### SOUTH_WEST

public static final BlockFace SOUTH_WEST

### WEST_NORTH_WEST

public static final BlockFace WEST_NORTH_WEST

### NORTH_NORTH_WEST

public static final BlockFace NORTH_NORTH_WEST

### NORTH_NORTH_EAST

public static final BlockFace NORTH_NORTH_EAST

### EAST_NORTH_EAST

public static final BlockFace EAST_NORTH_EAST

### EAST_SOUTH_EAST

public static final BlockFace EAST_SOUTH_EAST

### SOUTH_SOUTH_EAST

public static final BlockFace SOUTH_SOUTH_EAST

### SOUTH_SOUTH_WEST

public static final BlockFace SOUTH_SOUTH_WEST

### WEST_SOUTH_WEST

public static final BlockFace WEST_SOUTH_WEST

### SELF

public static final BlockFace SELF

## Method Details

### values

public static BlockFace[] values()
Returns an array containing the constants of this enum class, in the order they are declared.

Returns:
  an array containing the constants of this enum class, in the order they are declared

### valueOf

public static BlockFace valueOf(String name)
Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)

Parameters:
  `name` - the name of the enum constant to be returned.
Returns:
  the enum constant with the specified name
Throws:
  `IllegalArgumentException` - if this enum class has no constant with the specified name
  `NullPointerException` - if the argument is null

### getModX

public int getModX()
Get the amount of X-coordinates to modify to get the represented block

Returns:
  Amount of X-coordinates to modify

### getModY

public int getModY()
Get the amount of Y-coordinates to modify to get the represented block

Returns:
  Amount of Y-coordinates to modify

### getModZ

public int getModZ()
Get the amount of Z-coordinates to modify to get the represented block

Returns:
  Amount of Z-coordinates to modify

### getDirection

@NotNull public @NotNull Vector getDirection()
Gets the normal vector corresponding to this block face.

Returns:
  the normal vector

### isCartesian

public boolean isCartesian()
Returns true if this face is aligned with one of the unit axes in 3D Cartesian space (ie NORTH, SOUTH, EAST, WEST, UP, DOWN).

Returns:
  Cartesian status

### getOppositeFace

@NotNull public @NotNull BlockFace getOppositeFace()